/*
Copyright © 2011 Marco Mescoli, Erio Orlandi, Franco Melchionna,
Andrea Gavioli, Federico Carnevali, Mario Benito Totaro

This file is part of roboino project.
roboino is a little educational robot with free firmware:
you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
roboino project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with roboino project. If not, see <http://www.gnu.org/licenses/>.
*/

//codice joystick bluetooth per app android carnevali
//versione compatibile con roboino v3
//#define LEDeXT LEDwHITE //se usato su roboino v1

#define DCOPTOsXACLK 6
#define DCOPTOsXCLK 5

#define DCOPTOdXACLK 9
#define DCOPTOdXCLK 10

#define maxSpeed 100 //da 0 a 255 definisce massima velocità
bool FC,FS,FD;
bool lL=false, lR=false, lC=false;

int dove=1;
char RxFollow;

void vigile() {
  // routine di Andrea per gli incroci programmati su pista
  Serial.print( "liveAs: programmed path.\r\n" );
  while (true) {
    FC=digitalRead(OPTOcX);
    FS=digitalRead(OPTOsX);
    FD=digitalRead(OPTOdX);
    
    digitalWrite(A3,FS);
    digitalWrite(A4,FC);
    digitalWrite(A5,FD);

    if (FC==HIGH && FS==LOW && FD==LOW)
    {
      avanti();
      lC=true;
    }
    else if ((FC==LOW && FS==LOW && FD==HIGH) || (FC==HIGH && FS==LOW && FD==HIGH))
    {
      destra();
      lC=false;
    }
    else if ((FC==LOW && FS==HIGH && FD==LOW) || (FC==HIGH && FS==HIGH && FD==LOW))
    {
      sinistra();
      lC=false;
    }
    else if ((FC==LOW && FS==LOW && FD==LOW)||(FC==HIGH && FS==HIGH && FD==HIGH))
    {
      if (lC==true)
      {
        avanti();
      }
      else
      {
        if (lL==true)
        {
          sinistra();
        }
        if (lR==true)
        {
          destra();
        }
      }
    }
    else if (FC==LOW && FS==HIGH && FD==HIGH)
    {
      fermo();
      Serial.println(dove); //in base RxFollow dove mi dice dove dovrò andare
      do {
      while(!Serial.available());
      RxFollow=Serial.read();
      } while (RxFollow!='F' && RxFollow!='B' && RxFollow!='C');
      delay(1000);
      
      if (RxFollow=='F') //51=avanti
      {
        if (dove==1)
        {
          dove=4;
        }
        else if (dove==2)
        {
          dove=3;
        }
        else if (dove==3)
        {
          dove=2;
        }
        else if (dove==4)
        {
          dove=1;
        }
        while(digitalRead(OPTOsX)==LOW || digitalRead(OPTOdX)==LOW)//HIGH è nero
        {
          avanti();
        }
        while(digitalRead(OPTOcX)==HIGH)
        {
          avanti();
        }
        fermo();
        delay(500);
      }
      else if (RxFollow=='B') //51=sinistra
      {
        if (dove==1)
        {
          dove=1;
        }
        else if (dove==2)
        {
          dove=4;
        }
        else if (dove==3)
        {
          dove=3;
        }
        else if (dove==4)
        {
          dove=2;
        }
        while(digitalRead(OPTOsX)==LOW || digitalRead(OPTOdX)==LOW) //HIGH è nero
        {
          avanti();
          delay(1);
        }
        while(digitalRead(OPTOsX)==HIGH)
        {
          sinistra();
          delay(1);
        }
        while(digitalRead(OPTOsX)==LOW)
        {
          sinistra();
          delay(1);
        }
        while(digitalRead(OPTOsX)==HIGH)
        {
          sinistra();
          delay(1);
        }
      }
      else if (RxFollow=='C') //51=destra
      {
        if (dove==1)
        {
          dove=3;
        }
        else if (dove==2)
        {
          dove=2;
        }
        else if (dove==3)
        {
          dove=1;
        }
        else if (dove==4)
        {
          dove=4;
        }
        while(digitalRead(OPTOsX)==LOW || digitalRead(OPTOdX)==LOW) //HIGH è nero
        {
          avanti();
          delay(1);
        }
        while(digitalRead(OPTOdX)==HIGH)
        {
          destra();
          delay(1);
        }
        while(digitalRead(OPTOdX)==LOW)
        {
          destra();
          delay(1);
        }
        while(digitalRead(OPTOdX)==HIGH)
        {
          destra();
          delay(1);
        }
      }
      
      delay(1);
          
    }

    if(FD==HIGH)
    {
      lR=true;
      lL=false;
    }
    if(FS==HIGH)
    {
      lL=true;
      lR=false;
    }
  }
}

void avanti()
{
  analogWrite(DCOPTOsXACLK,maxSpeed);
  digitalWrite(DCOPTOsXCLK,LOW);
  analogWrite(DCOPTOdXACLK,maxSpeed);
  digitalWrite(DCOPTOdXCLK,LOW);
}
void sinistra()
{
  analogWrite(DCOPTOsXACLK,maxSpeed);
  digitalWrite(DCOPTOsXCLK,LOW);
  digitalWrite(DCOPTOdXACLK,HIGH);
  digitalWrite(DCOPTOdXCLK,HIGH);
}
void destra()
{
  digitalWrite(DCOPTOsXACLK,HIGH);
  digitalWrite(DCOPTOsXCLK,HIGH);
  analogWrite(DCOPTOdXACLK,maxSpeed);
  digitalWrite(DCOPTOdXCLK,LOW);
}
void fermo()
{
  digitalWrite(DCOPTOsXACLK,HIGH);
  digitalWrite(DCOPTOsXCLK,HIGH);
  digitalWrite(DCOPTOdXACLK,HIGH);
  digitalWrite(DCOPTOdXCLK,HIGH);
}
void indietro()
{
  digitalWrite(DCOPTOsXACLK,LOW);//indietro
  analogWrite(DCOPTOsXCLK,50);
  digitalWrite(DCOPTOdXACLK,LOW);
  analogWrite(DCOPTOdXCLK,50);
}